<template>
  <el-button @click="apply" type="primary" plain> Добавить </el-button>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "../common/ComponentMixin";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import { AxiosInstance } from "@/modules/AxiosInstance";
import { Channel } from "@/interfaces/Channel";

/**
 * Компонент применения добавления базовой аудитории.
 */
@Component
export default class ComponentAddChannelBaseAudience extends Mixins(
  ComponentMixin
) {
  // Id выбранного канала
  private palomarsChannelID: number | null = null;
  // Id выбранной базовой аудитории
  private audience: number | null = null;
  // Выбранная дата
  private date: Date | null = null;

  /**
   * Метод срабатывает после нажатия кнопки "Добавить базовую аудиторию".
   */
  private apply(): void {
    // Вызываем метод проверки
    if (!this.checkParameter()) return;

    this.save();
  }

  /**
   * Метод срабатывает при создании компонента.
   */
  protected created(): void {
    this.subscribeAll([
      // Подписываемся на события
      ["on-selected-channels", this.getChannelTvr],
      ["selected-tvr-id", this.getTvr],
      ["selection-date-tvr", this.dateTvr],
    ]);
  }

  /**
   * Метод провекри
   */
  private checkParameter(): boolean | undefined {
    if (!this.palomarsChannelID || this.palomarsChannelID === 0) {
      this.notifyError("Не указан канал.");
      return;
    }
    if (!this.audience || this.audience === 0) {
      this.notifyError("Не указана целевая аудитория.");
      return;
    }
    if (!this.date) {
      this.notifyError("Не указана дата.");
      return;
    }
    return true;
  }

  /**
   * Метод получения id канала из автобуса события.
   * @param channelTvr
   */
  private getChannelTvr(channelTvr: Channel): void {
    if (channelTvr.palomarsChannelID == null) {
      this.notifyError("Канал не имеет Palomars ID");
      return;
    }

    this.palomarsChannelID = channelTvr.palomarsChannelID;
  }

  /**
   * Метод получения id аудитории из автобуса события.
   * @param audience
   */
  private getTvr(audience: number): void {
    this.audience = audience;
  }

  /**
   * Метод получения выбранной даты из автобуса события.
   * @param date
   */
  private dateTvr(date: Date): void {
    this.date = date;
  }

  /**
   * Метод сохранения связей.
   */
  @AsyncRequestCatchException
  private async save(): Promise<void> {
    await AxiosInstance.post("/channels/save-palomars-channel-x-audience", {
      palomars_channel_id: this.palomarsChannelID,
      audience_id: this.audience,
      date: this.date,
    });
    this.$notify({
      type: "success",
      title: "Параматры базовой аудитории",
      message: "Базовая аудитория сохранена",
    });

    this.notify("reload-table");
  }

  private notifyError(message: string): void {
    this.$notify({
      type: "error",
      title: "Ошибка параметров",
      message: message,
    });
  }
}
</script>
<style scoped lang="scss">
.el-button {
  width: 100%;
}
</style>
